////This Windows C++ Console App demonstrates, simply the
////code required to call functions in mpTwist3.dll.
////in a C++ Windows Application.

//There Should Be a copy of the mpTwist3.dll file, included in this
//demo, in this demo apps working directory, when you test it.

//When using mpTwist3.dll with you C++ projects,
//No installation is required, just copy mpTwist3.dll into the 
//directory of your application project.

//When you package your app. for distribution, add mpTwist3.dll 
//to your package (no dependencies or .dep files are required)
//and install mpTwist3.dll (just copy it, like a data file) 
//into the directory where you install your .exe file, 
//or into Windows\System or Windows directory if you prefer

// mpTwist3.dll is Copyright 2004 Microprosa Software

//Speed Comparison
//mpTwist3.dll is about 10-20% faster than c++ rand() function
//and about 33% faster than the Mersenne Twister code.
// 1 mill loop-calls in  31 ms
// 2 mill loop-calls in  62 ms 
// 3 mill loop-calls in  94 ms 
// about 32 million loop calls per sec.

#include <iostream>     //Header file containing cout and endl 
#include <conio.h>      //Header file containing getch() prototype
#include <windows.h>    //

//variable to send Register Key parameter, = 0 here, unregistered. 
unsigned long rgke = 0;
unsigned long rgke2 = 0;

//variable to send initial seed no. parameter to generator. 
//any 32 bit number is okay, loaded below. (irrelevant, if unregistered)        
unsigned long seed; 

//variables used to receive the dll functions' return values
unsigned long a;
long b;
double c;
double d;
double e;   

//misc. for this demo app.
using namespace std; 

int main()
{
///////////////Begin Explicit Linking the dll to this app./////////////////
//Each of the mpTwist3.dll's 7 functions, use two declared
//names, here, which you can change to suit you.
//For Example, for the 1st function I used MYFUN1 and Reg_Key.
//note: if you change the names here, you must also change

// type definition, pointers to each of the dll's 7 functions ////
  typedef void (*MYFUN1)(unsigned long, unsigned long); 
  typedef void (*MYFUN2)(unsigned long); 
  typedef unsigned long (*MYFUN3)(void); 
  typedef long (*MYFUN4)(void);  
  typedef double (*MYFUN5)(void);
  typedef double (*MYFUN6)(void);
  typedef double (*MYFUN7)(void);

// declarations for the dll's 7 typedef functions /////////
  MYFUN1  Init_KeyNo; 
  MYFUN2  Init_Gen;
  MYFUN3  Gen_Int32; 
  MYFUN4  Gen_Int31;
  MYFUN5  Gen_Real;
  MYFUN6  Gen_Real7;
  MYFUN7  Gen_Real15;

// load the dll //////////////////////////////////////////////
  HMODULE hMod;               // handle to loaded library module
  BOOL    bRes;               // BOOL to check if dll was successfully unloaded
  // returns a handle to the dll, otherwise NULL
  hMod = LoadLibrary("mpTwist3.dll"); 
  if (hMod == NULL)
     goto nadalode;
// Note: when done using the dll, unload it with the FreeLibrary Function (see, near bottom)

  // returns the address of each of the dll's 7 functions (otherwise NULL)
  Init_KeyNo = (MYFUN1) GetProcAddress(hMod, "init_keyno");     //register key number obtained by purchasing this dll
  Init_Gen = (MYFUN2) GetProcAddress(hMod, "init_gen");       //seed generator
  Gen_Int32 = (MYFUN3) GetProcAddress(hMod, "gen_int32");      //generates a random number on [0,0xffffffff]-interval, 0 to 2^32
  Gen_Int31 = (MYFUN4) GetProcAddress(hMod, "gen_int31");       //generates a random number on [0,0x7fffffff]-interval, 0 to 2^32 - 1
  Gen_Real = (MYFUN5) GetProcAddress(hMod, "gen_real");           //generates a random number on [0,1)-real-interval, 0 to 0.99999999976716936 
  Gen_Real7 = (MYFUN6) GetProcAddress(hMod, "gen_real7");    //generates a random number on [0,1)-real-interval, 0 to .9999999    
  Gen_Real15 = (MYFUN7) GetProcAddress(hMod, "gen_real15");   //generates a random number on [0,1)-real-interval, 0 to 0.999999999767169
///////////////End, Explicit Linking the dll to this app./////////////////


//////////////////////////////////////////////////////////////////////////////////
//The dll's 7 Functions:
//1st. Init_KeyNo - Sends The dll its Two Register Keys, both 0 If unregistered.
//Also, if unregistered, the PRNG (generator) will only produce 624 random numbers, 
//then it will repeat them, over and over again. but it will do this in its 
//normal process, so you can test it this way.

//Important: After you purchase a register key, always initialize the dll by sending it your
//two register key numbers (order irrelevant) with this function (once per app run), before 
//calling any of the other functions, otherwise the dll will not accept the key until you 
//unload and reopen the app.

//(Dll function call) (function parameters)
   Init_KeyNo(rgke, rgke2);

/////////////////////////////////////////////////////////////////////////////////
//2nd. Init_Gen - sends a seed number to be used to initialize 
//the generator process(optonal, it will seed itself otherwise). 
  //I'm using the tick count for an initial seed number, here,
  //even though the demo will disregard this and will seed itself, 
  //and then will reseed itself with the same number every 625 calls.
   seed = GetTickCount();
//(Dll function call) (function parameters) 
   Init_Gen(seed);

//////////////////////////////////////////////////////////////////////////////////
//You can use any or all of the dll's 3nd through 7th Functions.
//Each returns a different kind of  Random number,
//one return number per call, as follows:

//3rd. Gen_Int32  - returns a 32 bit unsigned long from 0 to 4,294,967,295 which =(2^32 - 1).
//4th. Gen_Int31  - returns a 31 bit unsigned long from 0 to 2,147,483,647 which =(2^31 - 1).
//5th. Gen_Real - returns a double from 0 to 0.99999999976716936 which =(2^32 - 1) / (2^32).
//6th. Gen_Real17 - returns a double from 0 to 0.9999999 (above max. val limited so Visual Basic Single Data Type will not round to 1)
//7th. Gen_Real115 - returns a double from 0 to 0.999999999767169 (above max. val limited so Visual Basic Double Data Type will not round to 1)

// The dll's 3nd function returns a 32 bit unsigned long
// (Dll function call) (no function parameters)
    a = Gen_Int32();

  cout << " The 1st and 2nd functions have initialized the Dll." << endl;
 
  cout << "\n The 3nd function returns a 32 bit unsigned long: " << a << endl;
  cout << " Press any key for next function" << endl;
  getch();

// The dll's 4th function returns a 31 bit positive long
// (Dll function call) (no function parameters)
    b = Gen_Int31();
 
  cout << "\n The 4th function returns a 31 bit positive long: " << b << endl;
  cout << " Press any key for next function" << endl;
  getch();

// The dll's 5th function returns a double from 0 to 0.99999999976716936
// (Dll function call) (no function parameters)
    c = Gen_Real();
 
  printf("\n 5th returns a double from 0 to 0.99999999976716936: %1.18g ", c);
  cout << "\n Press any key for next function" << endl;
  getch();

// The dll's 6th function returns a double from 0 to .9999999
// (Dll function call) (no function parameters)
    d = Gen_Real7();
 
  printf("\n 6th returns a double from 0 to .9999999: %1.7g ", d);
  cout << "\n Press any key for next function" << endl;
  getch();

// The dll's 7th function returns a double from 0 to 0.999999999767169
// (Dll function call) (no function parameters)
    e = Gen_Real15();
 
  printf("\n 7th returns a double from 0 to 0.999999999767169: %1.15g ", e);
  cout << "\n Press any key roll out 250 numbers" << endl;
  getch();

//I'm using the 6th function, again, here to generate several numbers.
    int i;
    printf("\n 250 returns of the 7th function, gen_real15()\n");
    printf("\n");
    for (i=0; i<250; i++) {
      printf("\n %1.15g ", Gen_Real15());
      //if (i%5==4) printf("\n");
    }
  cout << "\n --------------------------------------------------------" << endl;
  cout << "\n Done, 250 returns of the 7th function, gen_real15()" << endl;

////////////////////////////////////////////////////////////////////
  // Unload the dll. returns nonzero if sucussful 
  bRes = FreeLibrary(hMod);
///////////////////////////////////////////////////////////////////

goto okeeload;    ///skip error loading stuff just below

nadalode:
  cout << "\n Could not find the Dll or could not load it." << endl;

okeeload:
// Okay, that's it. Get out of here.
  cout << "\n Press a key to exit" << endl;
  getch();

  return 0;
}
